<?php

class CambioReal_Pay_Block_Info extends Mage_Sales_Block_Order_Info
{
    protected function _construct()
    {
        parent::_construct();
        $this->setTemplate('cambioreal/info.phtml');

        require_once dirname(dirname(__FILE__)) . '/bootstrap/start.php';
    }

    public function getTransactionLinkHtml()
    {
        $payment = $this->getOrder()->getPayment();
        $cr_token = $payment->getData('cr_token');

        $response = \CambioReal\CambioReal::get(array('token' => $cr_token));

        if ( ! empty($response))
        {
            if ($response->status === 'success')
            {
                return ($response->data->payment_method == 'boleto') ? $this->getBoletoHtml($response->data->ticket) : $this->getTicketHtml($response->data->ticket);
            }
        }

        return null;
    }

    /**
     * @return string
     */
    protected function getBoletoHtml($link)
    {
        $html = '<p>';
            $html .= '<a href="' . $link . '" target="_blank" style="display:inline-block;text-align:center">';
                $html .= '<img src="' . Mage::getDesign()->getSkinUrl('images/cambioreal/boleto-checkout-success.png') . '" alt="" style="margin:0 auto;max-height:108px">';
                $html .= '<br>' . __('Click here to print the boleto');
            $html .= '</a>';
        $html .= '</p>';

        return $html;
    }

    /**
     * @return string
     */
    protected function getTicketHtml($link)
    {
        $html = '<p>';
            $html .= '<a href="' . $link . '" target="_blank">';
                $html .= __('Click here to access the transaction details');
            $html .= '</a>';
        $html .= '</p>';

        return $html;
    }
}